Imports System.IO

Public Class RSSPECAN_Hardcopy_Example

    Private Sub ExitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitButton.Click
        Close()
    End Sub

    Private Sub OpenButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenButton.Click

        If saveFileDialog1.ShowDialog() = DialogResult.OK Then
            textBox1.Text = saveFileDialog1.FileName
        End If

    End Sub

    Private Sub SaveButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveButton.Click

        Dim m_Instrument As rsspecan = Nothing
        Dim tempFilePath As String = ""

        Try
            UseWaitCursor = True
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor

            ' initialize driver
            If m_Instrument Is Nothing Then
                m_Instrument = New rsspecan(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked)
            ElseIf ResetDevice.Checked Then
                m_Instrument.reset()
            End If

            ' switch device display on/off
            m_Instrument.ConfigureDisplayUpdate(DisplayEnable.Checked)

            ' configure hardcopy options
            m_Instrument.ConfigureHardcopyDevice(1, 1, 0)

            ' select temporary file location
            If (InstrType.SelectedIndex = 1) Then
                tempFilePath = "D:\user\output.wmf"
            Else
                tempFilePath = "C:\R_S\instr\user\output.wmf"
            End If

            ' configure hardcopy save file
            m_Instrument.HardcopySetFileName(tempFilePath)

            ' save screen image to file
            m_Instrument.HardcopyPrint(1, 0)

            If File.Exists(textBox1.Text) = False Then

                If saveFileDialog1.ShowDialog() = DialogResult.OK Then
                    textBox1.Text = saveFileDialog1.FileName
                Else
                    Return
                End If
            End If

            ' copy file from instrument to controler
            m_Instrument.ReadToFileFromInstrument(tempFilePath, textBox1.Text)

            ' delete temporary file
            m_Instrument.FileManagerOperations(3, tempFilePath, "")


        Catch ex As System.Runtime.InteropServices.ExternalException

            Dim message As String

            message = "Instrument Status Error: " + ex.Message + Environment.NewLine
            message += "Instrument Error Code: " + ex.ErrorCode.ToString("X")
            MessageBox.Show(message)

        Finally

            System.Windows.Forms.Cursor.Current = Cursors.Default
            UseWaitCursor = False

        End Try

    End Sub

    Private Sub RSSPECAN_Hardcopy_Example_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        InstrType.SelectedIndex = 0
    End Sub
End Class
