Public Class Rsspecan_Peak_List_Example

    Private Sub ExitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitButton.Click
        Close()
    End Sub

    Private Sub StartButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartButton.Click

        Dim m_Instrument As rsspecan = Nothing
        Dim timeout As Integer = 15000    ' default value
        Dim i As Integer
        Dim peakList(50) As Double

        Try
            UseWaitCursor = True
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor

            ' initialize driver
            If m_Instrument Is Nothing Then
                m_Instrument = New rsspecan(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked)
            ElseIf ResetDevice.Checked Then
                m_Instrument.reset()
            End If

            ' switch device display on/off
            m_Instrument.ConfigureDisplayUpdate(DisplayEnable.Checked)

            ' Set instrument to single sweep mode - continous mode is done
            ' programmatically because this is the only way how to
            ' synchronize measurement using *OPC
            m_Instrument.ConfigureSignalStatisticSweep(False)

            ' configure specan device: center frequency and span
            m_Instrument.ConfigureFrequencyCenterSpan(1, Convert.ToDouble(CenterFreq.Value), Convert.ToDouble(Span.Value))

            ' configure sweep time
            m_Instrument.ConfigureSweepCoupling(1, 2, Convert.ToDouble(SWT.Value))

            ' configure peak excursion
            m_Instrument.ConfigureMarkerSearchPeakExcursion(1, Convert.ToDouble(PeakEX.Value))

            timeout = Convert.ToInt32((SWT.Value * 1000) + 1000)

            ' do a sweep
            m_Instrument.Initiate(1, timeout)

            ' configure marker peak list
            m_Instrument.ConfigureMarkerPeakList(1, 1, Convert.ToInt32(PeakListValues.Value), 0)

            ' read marker peak list
            m_Instrument.QueryMarkerPeakList(1, 1, Convert.ToInt32(PeakListValues.Value), 0, peakList)

            PeakListTable.Rows.Clear()

            ' write peak list to table
            For i = 0 To (PeakListValues.Value - 1) Step 1

                PeakListTable.Rows.Add()
                PeakListTable.Rows(i).Cells("Frequency").Value = peakList(i)
            Next i


            ' read marker peak list
            m_Instrument.QueryMarkerPeakList(1, 1, Convert.ToInt32(PeakListValues.Value), 1, peakList)

            ' write peak list to table 
            For i = 0 To (PeakListValues.Value - 1) Step 1

                PeakListTable.Rows(i).Cells("Amplitude").Value = peakList(i)
            Next i


        Catch ex As System.Runtime.InteropServices.ExternalException

            Dim message As String

            message = "Instrument Status Error: " + ex.Message + Environment.NewLine
            message += "Instrument Error Code: " + ex.ErrorCode.ToString("X")
            MessageBox.Show(message)

        Finally

            System.Windows.Forms.Cursor.Current = Cursors.Default
            UseWaitCursor = False

        End Try

    End Sub
End Class
