Public Class Rsspecan_Phase_Noise_Example

    Private Sub ExitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitButton.Click
        Close()
    End Sub

    Private Sub StartButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartButton.Click

        Dim m_Instrument As rsspecan = Nothing
        Dim timeout As Integer = 15000    ' default value
        Dim result As Double

        Try
            UseWaitCursor = True
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor

            ' initialize driver
            If m_Instrument Is Nothing Then
                m_Instrument = New rsspecan(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked)
            ElseIf ResetDevice.Checked Then
                m_Instrument.reset()
            End If

            ' selects the spectrum analyzer mode '
            m_Instrument.SetSANMode()

            ' switch device display on/off
            m_Instrument.ConfigureDisplayUpdate(DisplayEnable.Checked)

            ' Set instrument to single sweep mode - continous mode is done
            ' programmatically because this is the only way how to
            ' synchronize measurement using *OPC
            m_Instrument.ConfigureSignalStatisticSweep(False)

            ' configure specan device: center frequency and span
            m_Instrument.ConfigureFrequencyCenterSpan(1, Convert.ToDouble(CenterFreq.Value), Convert.ToDouble(Span.Value))

            ' switch off phase noise marker measurement (for reseting measurement)
            m_Instrument.ConfigureMarkerPhaseNoiseMeasurement(1, False)

            ' disable all markers (for reseting markers)
            m_Instrument.DisableAllMarkers(1)
            m_Instrument.DisableAllDeltaMarkers(1)

            ' do a sweep
            m_Instrument.Initiate(1, timeout)

            ' switch on phase noise marker measurement
            m_Instrument.ConfigureMarkerPhaseNoiseMeasurement(1, True)

            ' change marker position
            m_Instrument.ConfigureDeltaMarkerPosition(1, 1, 1, Convert.ToDouble(MarkerPos.Value))

            ' read phase noise marker result
            m_Instrument.QueryPhaseNoiseResult(1, result)

            ' show phase noise marker result in front panel
            ResultTextBox.Text = result.ToString("E3") + " dBc/Hz"


        Catch ex As System.Runtime.InteropServices.ExternalException

            Dim message As String

            message = "Instrument Status Error: " + ex.Message + Environment.NewLine
            message += "Instrument Error Code: " + ex.ErrorCode.ToString("X")
            MessageBox.Show(message)

        Finally

            System.Windows.Forms.Cursor.Current = Cursors.Default
            UseWaitCursor = False

        End Try

    End Sub
End Class
