Public Class Rsspecan_CP_Measurement_Example

    Private Sub ExitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitButton.Click
        Close()
    End Sub

    Private Sub StartButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartButton.Click

        Dim m_Instrument As rsspecan = Nothing
        Dim timeout As Integer = 15000    ' default value
        Dim returnedValues As Integer
        Dim result(1) As Double

        Try
            UseWaitCursor = True
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor

            ' initialize driver
            If m_Instrument Is Nothing Then
                m_Instrument = New rsspecan(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked)
            ElseIf ResetDevice.Checked Then
                m_Instrument.reset()
            End If

            ' switch device display on/off
            m_Instrument.ConfigureDisplayUpdate(DisplayEnable.Checked)

            ' Set instrument to single sweep mode - continous mode is done
            ' programmatically because this is the only way how to
            ' synchronize measurement using *OPC
            m_Instrument.ConfigureSignalStatisticSweep(False)

            ' configure specan device: center frequency and span
            m_Instrument.ConfigureFrequencyCenterSpan(1, Convert.ToDouble(CenterFreq.Value), Convert.ToDouble(Span.Value))

            ' configure power measurement
            m_Instrument.SelectPowerMeasurement(1, True, 1)

            ' adjust power measurement settings
            m_Instrument.PowerAdjustReferenceLevel(1, 15000)

            ' do a sweep
            m_Instrument.Initiate(1, timeout)

            ' query channel power
            m_Instrument.QueryPowerResults(1, 1, 1, result, returnedValues)

            ' show channel power result in front panel textbox
            ResultTextBox.Text = "Channel power" + vbTab + result(0).ToString() + " dBm"


        Catch ex As System.Runtime.InteropServices.ExternalException

            Dim message As String

            message = "Instrument Status Error: " + ex.Message + Environment.NewLine
            message += "Instrument Error Code: " + ex.ErrorCode.ToString("X")
            MessageBox.Show(message)

        Finally

            System.Windows.Forms.Cursor.Current = Cursors.Default
            UseWaitCursor = False

        End Try

    End Sub
End Class
