Imports System.Text

Public Class Rsspecan_Wait_For_Calibration_End_Example

    Private Sub ExitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitButton.Click
        Close()
    End Sub

    Private Sub StartButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartButton.Click

        Dim m_Instrument As rsspecan = Nothing
        Dim timeout As Integer = 15000    ' default value
        Dim result32 As Integer
        Dim result16 As Short
        Dim messageSelfTest As StringBuilder = New StringBuilder(256)

        Try
            UseWaitCursor = True
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor

            ' initialize driver
            If m_Instrument Is Nothing Then
                m_Instrument = New rsspecan(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked)
            ElseIf ResetDevice.Checked Then
                m_Instrument.reset()
            End If

            ' switch device display on/off
            m_Instrument.ConfigureDisplayUpdate(DisplayEnable.Checked)

            If (CalEnd.Checked) Then

                ' Initiates the calibration and waits for its end
                m_Instrument.Calibration(True, timeout, result32)

                If (result32 = 0) Then
                    MessageBox.Show("Calibration successful", "Calibration Result")
                Else
                    MessageBox.Show("Calibration Error code: 0x" + result32.ToString("X8"), "Calibration Result")
                End If

            End If

            If (STestEnd.Checked) Then

                ' Initiates the self-test and waits for its end
                m_Instrument.self_test(result16, messageSelfTest)

                If (result16 = 0) Then
                    MessageBox.Show(messageSelfTest.ToString(), "Self Test Result")
                Else
                    MessageBox.Show(messageSelfTest.ToString() + "\nSelf Test Error code: 0x" + result16.ToString("X8"), "Self Test Result")
                End If

            End If


        Catch ex As System.Runtime.InteropServices.ExternalException

            Dim message As String

            message = "Instrument Status Error: " + ex.Message + Environment.NewLine
            message += "Instrument Error Code: " + ex.ErrorCode.ToString("X")
            MessageBox.Show(message)

        Finally

            System.Windows.Forms.Cursor.Current = Cursors.Default
            UseWaitCursor = False

        End Try

    End Sub

    Private Sub CalEnd_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CalEnd.CheckedChanged

        If (CalEnd.Checked) Then
            STestEnd.Checked = False
        End If

    End Sub

    Private Sub STestEnd_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles STestEnd.CheckedChanged

        If (STestEnd.Checked) Then
            CalEnd.Checked = False
        End If

    End Sub
End Class
