Public Class Rsspecan_Statistics_CCDF_Example

    Private Sub Rsspecan_Statistics_CCDF_Example_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Probability.SelectedIndex = 0
    End Sub

    Private Sub ExitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitButton.Click
        Close()
    End Sub

    Private Sub StartButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartButton.Click

        Dim m_Instrument As InstrumentDriversVB.rsspecan = Nothing
        Dim timeout As Integer = 15000    ' default value
        Dim result As Double

        Try
            UseWaitCursor = True
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor

            ' initialize driver
            If m_Instrument Is Nothing Then
                m_Instrument = New InstrumentDriversVB.rsspecan(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked)
            ElseIf ResetDevice.Checked Then
                m_Instrument.reset()
            End If

            ' switch device display on/off
            m_Instrument.ConfigureDisplayUpdate(DisplayEnable.Checked)

            ' Set instrument to single sweep mode - continous mode is done
            ' programmatically because this is the only way how to
            ' synchronize measurement using *OPC
            m_Instrument.ConfigureSignalStatisticSweep(False)

            ' configure specan device: center frequency and span
            m_Instrument.ConfigureFrequencyCenterSpan(1, Convert.ToDouble(CenterFreq.Value), Convert.ToDouble(Span.Value))

            ' configure parameters of signal statistic measurement
            m_Instrument.ConfigureSignalStatisticMeasurement(2, Convert.ToInt32(NumOfSamples.Value), Convert.ToDouble(ResBand.Value))

            ' do a sweep
            m_Instrument.Initiate(1, timeout)

            ' read out the Statistic CCDF level values
            m_Instrument.QuerySignalStatisticCCDFLevel(1, Probability.SelectedIndex, result)

            ' show result in front panel textbox
            ResultTextBox.Text = result.ToString() + " dB"


        Catch ex As System.Runtime.InteropServices.ExternalException

            Dim message As String

            message = "Instrument Status Error: " + ex.Message + Environment.NewLine
            message += "Instrument Error Code: " + ex.ErrorCode.ToString("X")
            MessageBox.Show(message)


        Finally

            System.Windows.Forms.Cursor.Current = Cursors.Default
            UseWaitCursor = False

        End Try

    End Sub
End Class
